/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-react-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-react-core";
import { IChartScaleLegend_$type } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, logBase } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let BubbleSeries = /*@__PURE__*/ (() => {
    class BubbleSeries extends ScatterBase {
        bc() {
            return new BubbleSeries();
        }
        get_dy() {
            return true;
        }
        cd() {
            return new BubbleSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.zj = a;
        }
        ir() {
            return 0.7;
        }
        t6() {
            if (this.t5 == 0) {
                return 2;
            }
            return super.t6();
        }
        constructor() {
            super();
            this.aa9 = null;
            this.aa8 = null;
            this.zw = null;
            this.zo = null;
            this.zn = null;
            this.zm = null;
            this.zk = null;
            this.ab = BubbleSeries.$;
            this.vx = new ScatterFrame();
            this.vz = new ScatterFrame();
            this.vv = new ScatterFrame();
        }
        isAttachedTo(a) {
            return this.ay == a;
        }
        dx() {
            return true;
        }
        n5(a) {
            super.n5(a);
            if (this.zr != null && this.zw != null && this.zw.count > 0) {
                for (let b = 0; b < this.zw.count; b++) {
                    a(this.zw._inner[b]);
                }
            }
        }
        get zq() {
            return this.zs;
        }
        aa7(a) {
            let b = typeCast(CustomPaletteBrushScale.$, this.zi);
            let c = typeCast(ValueBrushScale.$, this.zi);
            let d = this.zi;
            if (b != null && this.c7 != null) {
                return b.getBrush1(a, this.c7.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.zp);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        }
        get legendReady() {
            return this.zs != null && this.zs.count != 0;
        }
        get minScaleText() {
            let a = this.zh(this.zl).b;
            return (Math.round(a * 1000) / 1000).toString();
        }
        get maxScaleText() {
            let a = this.zh(this.zl).a;
            return (Math.round(a * 1000) / 1000).toString();
        }
        forScaleColors(a) {
            for (let b = 0; b < this.zs.count; b++) {
                if (this.zi == null || !this.zi.isReady) {
                    return false;
                }
                let c = NaN;
                if (this.zp != null) {
                    c = (this.zp.item(b) - this.zp.minimum) / (this.zp.maximum - this.zp.minimum);
                }
                let d = (this.zs.item(b) - this.zs.minimum) / (this.zs.maximum - this.zs.minimum);
                if (isNaN_(c)) {
                    c = 0;
                }
                if (isNaN_(d)) {
                    d = c;
                }
                let e = this.vc;
                let f = this.aa7(b);
                let g = f != null ? f : e;
                a(g, d);
            }
            return true;
        }
        jv(a, b) {
            let c = this.lw(b);
            if (c == BubbleSeries.$$p[5]) {
                return this.jw(a, b, this.aab);
            }
            if (c == BubbleSeries.$$p[11]) {
                return this.jw(a, b, this.aal);
            }
            if (c == ScatterBase.$$p[12]) {
                return this.jw(a, b, this.xn);
            }
            if (c == ScatterBase.$$p[16]) {
                return this.jw(a, b, this.xv);
            }
            if (c == BubbleSeries.$$p[2]) {
                return this.jw(a, b, this.z6);
            }
            return super.jv(a, b);
        }
        get zs() {
            return this.zo;
        }
        set zs(a) {
            if (this.zo != a) {
                let b = this.zs;
                this.zo = a;
                this.raisePropertyChanged("RadiusColumn", b, this.zs);
            }
        }
        get zr() {
            return this.zn;
        }
        set zr(a) {
            if (this.zn != a) {
                let b = this.zr;
                this.zn = a;
                this.raisePropertyChanged("LabelColumn", b, this.zr);
            }
        }
        get zp() {
            return this.zm;
        }
        set zp(a) {
            if (this.zm != a) {
                let b = this.zp;
                this.zm = a;
                this.raisePropertyChanged("FillColumn", b, this.zp);
            }
        }
        xy(a, b, c, d, e) {
            if (c <= this.w3) {
                b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            }
            let f = this.w3;
            let g = this.c7;
            let h;
            let i;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(0, d, e, this.vr.d, j);
            let l = new ScalerParams(0, d, e, this.vr.e, j);
            let m = false;
            let n = 0;
            if (this.cv != null) {
                if (this.cv.fc()) {
                    let o = this.cv.lp(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            for (let p = 0; p < c; p++) {
                h = this.wc.item(p);
                i = this.wd.item(p);
                let q = { $type: Point_$type, x: this.vr.a.ej(h, k), y: this.vr.b.ej(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!isInfinity(q.x) && !isInfinity(q.y)) {
                    let r = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r)) {
                            let s = { $type: Point_$type, x: h, y: i };
                            b.g.addItem(r, ((() => {
                                let $ret = new OwnedPoint();
                                $ret.a = r;
                                $ret.b = s;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            }
        }
        x8(a, b) {
            let c = typeCast(BubbleSeriesView.$, b);
            let d = c.cy;
            d.m = this.zs;
            super.x8(a, b);
            let e = Math.min(this.wc != null ? this.wc.count : 0, this.wd != null ? this.wd.count : 0);
            if (e < 1) {
                return;
            }
            c.dk();
            c.dl();
        }
        aaq() {
            if (this.cv == null) {
                return;
            }
            if (this.ay == null) {
                return;
            }
            if (this.ay.isItemwise) {
                let a = this.ay;
                this.ay.clearLegendItemsForSeries(this);
                this.aap();
                a.renderItemwiseContent(this);
            }
            if (this.ay.isScale) {
                let b = this.ay;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        }
        static zx(a, b, c, d, e) {
            if (e <= a || isNaN_(e) || isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            let f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        }
        static zy(a, b, c, d, logBase_, e) {
            let f = logBase(e, logBase_);
            let g = logBase(a, logBase_);
            let h = logBase(b, logBase_);
            return BubbleSeries.zx(g, h, c, d, f);
        }
        gm(a, b, c) {
            let d = super.gm(a, b, c);
            if (this.zs == null || this.c7 == null || this.zs.count == 0 || this.c7.count != this.zs.count) {
                d = false;
            }
            return d;
        }
        wm(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.xn == a || this.xv == a || this.aal == a) {
                return true;
            }
            return false;
        }
        aap() {
            let a = typeCast(IChartLegend_$type, this.ay);
            if (a == null || this.c7 == null) {
                return;
            }
            this.zw = new List$1(UIElement.$, 0);
            let b = typeCast(CustomPaletteBrushScale.$, this.zi);
            let c = typeCast(ValueBrushScale.$, this.zi);
            let d = this.zi;
            let e = this.zg();
            let f = e.b;
            let g = e.a;
            let h = this.c7;
            for (let i = 0; i < h.count; i++) {
                let j = null;
                if (c != null && this.zp != null) {
                    let k = this.zp.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                let l = new ContentControl();
                let m = this.zr != null && this.zr.item(i) != null ? this.zr.item(i).toString() : "";
                l.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    return $ret;
                })());
                let n = this.qv;
                if (n == null) {
                    n = this.cg.bn(this.cl);
                }
                l.ah = n;
                this.zw.add(l);
            }
        }
        np(a, b, c, d) {
            super.np(a, b, c, d);
            if (this.zl != null) {
                this.zl.aa();
            }
            if (this.zi != null) {
                this.zi.x();
            }
            this.aaq();
        }
        of() {
            super.of();
            this.aaq();
        }
        ol() {
            super.ol();
            this.aaq();
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    if (this.zl != null) {
                        this.zl.aa();
                    }
                    if (this.zi != null) {
                        this.zi.x();
                    }
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.zs);
                        c.deregisterColumn(this.zp);
                        c.deregisterColumn(this.zr);
                        this.zs = null;
                        this.zp = null;
                        this.zr = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.zs = this.c4(this.aal);
                        if (!stringIsNullOrEmpty(this.z6)) {
                            this.zp = this.c4(this.z6);
                        }
                        this.zr = this.c6(this.aab);
                    }
                    this.pr(false);
                    this.aaq();
                    break;
                case BubbleSeries.$$p[11]:
                    if (this.zl != null) {
                        this.zl.aa();
                    }
                    if (this.c7 != null) {
                        this.c7.deregisterColumn(this.zs);
                        this.zs = this.c4(this.aal);
                        this.aaq();
                    }
                    break;
                case "RadiusColumn":
                    if (this.zl != null) {
                        this.zl.aa();
                    }
                    this.vs.c0.g$i();
                    this.pr(this.fr && this.dp);
                    this.on();
                    break;
                case BubbleSeries.$$p[12]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.pr(false);
                    this.om();
                    break;
                case BubbleSeries.$$p[13]:
                    this.pr(false);
                    this.om();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.aaq();
                    break;
                case BubbleSeries.$$p[3]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.pr(false);
                    this.aaq();
                    this.om();
                    break;
                case BubbleSeries.$$p[4]:
                case BubbleSeries.$$p[8]:
                case BubbleSeries.$$p[7]:
                case BubbleSeries.$$p[6]:
                    this.pr(false);
                    this.aaq();
                    this.om();
                    break;
                case "FillColumn":
                    this.pr(this.fr && this.dp);
                    this.om();
                    break;
                case BubbleSeries.$$p[2]:
                    if (this.zi != null) {
                        this.zi.x();
                    }
                    if (this.c7 != null) {
                        this.c7.deregisterColumn(this.zp);
                        this.zp = this.c4(this.z6);
                        this.aaq();
                    }
                    break;
                case BubbleSeries.$$p[5]:
                    if (this.c7 != null) {
                        this.c7.deregisterColumn(this.zr);
                        this.zr = this.c6(this.aab);
                        this.aaq();
                    }
                    break;
                case "ActualLegend":
                    let e = typeCast(IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        let f = typeCast(IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        let g = typeCast(IChartScaleLegend_$type, e);
                        let h = true;
                        let i = null;
                        if (this.cv != null) {
                            for (let j of fromEnum(this.cv.series)) {
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                        }
                    }
                    this.aaq();
                    break;
                case "SeriesViewer":
                    this.aaq();
                    break;
            }
        }
        updateSizeScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.zs != null) {
                a.b = this.zs.minimum;
                a.a = this.zs.maximum;
            }
            if (this.zl != null) {
                this.zl.ab(a.b, a.a);
            }
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.zp != null) {
                a.b = this.zp.minimum;
                a.a = this.zp.maximum;
            }
            if (this.zi != null) {
                this.zi.z(a.b, a.a);
            }
        }
        zh(a) {
            let b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.zs != null) {
                b.b = this.zs.minimum;
                b.a = this.zs.maximum;
            }
            if (a != null) {
                a.x();
                if (this.zv) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        }
        zg() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.zp != null) {
                a.b = this.zp.minimum;
                a.a = this.zp.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.zi);
            if (b != null) {
                b.s();
                if (this.zt && this.zi.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        aas(a, b, c, d) {
            let e = c.width;
            if (!this.cg.bx.isEmpty) {
                e = this.cg.bx.width;
            }
            else if (this.cv != null && !this.cv.t6.isEmpty) {
                e = this.cv.t6.width;
            }
            let f = DeviceUtils.c(e);
            this.zk = this.zl || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (this.zk != null) {
                let g = this.zk.minimumValue;
                let h = this.zk.maximumValue;
                let i = this.zk.logarithmBase;
                let j = this.zh(this.zk);
                let k = j.b;
                let l = j.a;
                if (this.zk.isLogarithmic) {
                    for (let m = 0; m < b.count; m++) {
                        b._inner[m] = BubbleSeries.zy(k, l, g, h, i, b._inner[m]);
                    }
                }
                else {
                    for (let n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.zx(k, l, g, h, b._inner[n]);
                    }
                }
            }
            let o = 1;
            o = DeviceUtils.d();
            let p = this.zl == null;
            if (d) {
                let q = c.width / e;
                for (let r = 0; r < b.count; r++) {
                    if (p) {
                        b._inner[r] = b._inner[r] / o;
                    }
                    b._inner[r] = b._inner[r] * q;
                }
            }
            for (let s = 0; s < a.count; s++) {
                let t = a._inner[s];
                if (p && !d) {
                    t.width = Math.max(0, b._inner[s] / o);
                    t.height = Math.max(0, b._inner[s] / o);
                }
                else {
                    t.width = Math.max(0, b._inner[s]);
                    t.height = Math.max(0, b._inner[s]);
                }
            }
        }
        aar(a) {
            let b = typeCast(BubbleSeriesView.$, this.cf);
            this.zj.b6 = false;
            if (b != null) {
                b.b6 = false;
            }
            let c = typeCast(CustomPaletteBrushScale.$, this.zi);
            let d = typeCast(ValueBrushScale.$, this.zi);
            let e = this.zi;
            let f = this.zg();
            let g = f.b;
            let h = f.a;
            let i = this.zi == null || !this.zi.isReady || (d != null && this.z6 == null);
            if (i) {
                this.zj.dj();
                if (b != null) {
                    b.dj();
                }
                return;
            }
            this.zj.b6 = true;
            if (b != null) {
                b.b6 = true;
            }
            let j = a.count;
            let k = this.c7;
            for (let l = 0; l < j; l++) {
                let m = a._inner[l];
                let n = typeCast(DataContext.$, m.content);
                if (n != null) {
                    let o = null;
                    let p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.zp != null) {
                        let q = this.zp.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.ve == null) {
                            o = this.vc;
                        }
                        else {
                            o = this.ve;
                        }
                    }
                    let r = null;
                    if (this.vf == null) {
                        r = this.vd;
                    }
                    else {
                        r = this.vf;
                    }
                    if (this.zu && o != null) {
                        r = o;
                    }
                    if (r != null && !isNaN_(this.z0)) {
                        r = BrushUtil.m(r, this.z0);
                    }
                    if (o != null && !isNaN_(this.zz)) {
                        o = BrushUtil.m(o, this.zz);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.js(c);
            let e = d == null ? NaN : this.h2(d, "XMemberPath");
            let f = d == null ? NaN : this.h2(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.a = 13;
            g.l = e;
            g.p = "X";
            g.q = this.xn != null ? this.xn : "X";
            g.r = this.xj != null ? this.xj : "X:";
            g.s = this.xl != null ? this.xl : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.p = "Y";
            h.q = this.xv != null ? this.xv : "Y";
            h.r = this.xr != null ? this.xr : "Y:";
            h.s = this.xt != null ? this.xt : "";
            let i = new DataLegendSeriesContext();
            i.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.b = this.aw();
            if (!stringIsNullOrEmpty(this.aal)) {
                let j = d == null ? NaN : this.h2(d, "RadiusMemberPath");
                let k = new DataLegendSeriesValueInfo();
                k.l = j;
                k.a = 11;
                k.p = "Radius";
                k.q = this.aal != null ? this.aal : "Radius";
                k.r = this.aah != null ? this.aah : "R:";
                k.s = this.aaj != null ? this.aaj : "";
                i.f.add(k);
            }
            else if (this.zk != null) {
                let l = new DataLegendSeriesValueInfo();
                l.l = this.zk.maximumValue;
                l.a = 11;
                l.p = "Radius";
                l.q = this.aal != null ? this.aal : "Radius";
                l.r = this.aah != null ? this.aah : "R:";
                l.s = this.aaj != null ? this.aaj : "";
                i.f.add(l);
            }
            if (!stringIsNullOrEmpty(this.z6)) {
                let m = d == null ? NaN : this.h2(d, "FillMemberPath");
                let n = new DataLegendSeriesValueInfo();
                n.l = m;
                n.a = 12;
                n.p = "Fill";
                n.q = this.z6 != null ? this.z6 : "Fill";
                n.r = this.z2 != null ? this.z2 : "F:";
                n.s = this.z4 != null ? this.z4 : "";
                i.f.add(n);
            }
            return i;
        }
        get actualMarkerBrush() {
            return this.vc;
        }
    }
    BubbleSeries.$t = /*@__PURE__*/ markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:z2:aat', [2, null], 'FillMemberAsLegendUnit:z4:aau', [2, null], 'FillMemberPath:z6:aav', [2], 'FillScale:zi:aaw', [BrushScale.$], 'FillScaleUseGlobalValues:zt:aax', [0, false], 'LabelMemberPath:aab:aay', [2], 'MarkerBrushBrightness:zz:aaz', [1, NaN], 'MarkerOutlineBrightness:z0:aa0', [1, NaN], 'MarkerOutlineUsesFillScale:zu:aa1', [0, false], 'RadiusMemberAsLegendLabel:aah:aa2', [2, null], 'RadiusMemberAsLegendUnit:aaj:aa3', [2, null], 'RadiusMemberPath:aal:aa4', [2, null], 'RadiusScale:zl:aa5', [SizeScale.$], 'RadiusScaleUseGlobalValues:zv:aa6', [0, false]]);
    return BubbleSeries;
})();
/**
 * @hidden
 */
export let CustomPaletteBrushScale = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScale extends BrushScale {
        constructor() {
            super();
        }
        getBrush1(a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return super.getBrush(a % this.brushes.count);
            }
            let c = BubbleSeries.zx(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        }
        get_isReady() {
            return this.brushes != null && this.brushes.count > 0;
        }
    }
    CustomPaletteBrushScale.$t = /*@__PURE__*/ markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, /*@__PURE__*/ enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
})();
/**
 * @hidden
 */
export let BubbleSeriesView = /*@__PURE__*/ (() => {
    class BubbleSeriesView extends ScatterBaseView {
        constructor(a) {
            super(a);
            this.di = null;
            this.di = a;
            this.c0 = new ScatterTrendLineManager();
        }
        au() {
            super.au();
            if (!this.q) {
                this.b4.uc = Defaults.e;
            }
        }
        cx() {
            return new BubbleMarkerManager((a) => this.c1.item(a), (a) => this.cz.vr.c.item(a), runOn(this, this.dc), runOn(this, this.cu), runOn(this, this.c2));
        }
        dk() {
            let a = this.cy;
            this.di.aas(a.n, a.o, this.bx, this == this.e.cf);
            this.as();
        }
        dl() {
            let a = this.cy;
            this.di.aar(a.n);
        }
        dj() {
            let a = this.cy;
            for (let b of fromEnum(a.n)) {
                let c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a3.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.di.title + "</span><br/><span>" + "(${item." + this.di.xn + "}, ${item." + this.di.xv + "})</span>";
            if (!stringIsNullOrEmpty(this.di.aal)) {
                a += "<span>, Radius: ${item." + this.di.aal + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    BubbleSeriesView.$t = /*@__PURE__*/ markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
})();
